#include "mail.h"

/*==============================================================================
  Interface de l'objet: Initialise ws2_32.dll, lance le thread
==============================================================================*/
void mail_Check_Periodique()
{
  // Initialise ws2_32.dll
     WSADATA wsa;
     if (WSAStartup(0x0202, &wsa) != 0)
     {
       socket_error("WSAStartup()");
       exit(1);
     }
  
  // Lance thread de connection au serveur de messagerie
     _beginthread(POP_Thread,0,NULL);
}

/*==============================================================================
  Thread de connection au serveur.
  Chaque minute, pour chaque boite, dcrmente next_check de 1.
  Quand next_check = 0, se connecte et remet next_check  l'intervalle voulu.
  Un intervalle  0 dsactive le check.
==============================================================================*/
static void POP_Thread(PVOID pvoid)
{
  register int n;
  while(1)
  {
    for (n=0; n<nbboites; n++)
    {
      if (b[n].intervalle && --c[n].next_check == 0)
      {
        //say("check"); say(b[n].nom);
        mail_check (n); // nouveaux messages?
        c[n].next_check = b[n].intervalle;
      }
    }
    sleep(60000); // attend 1 minute
  }
}

/*==============================================================================
  Affiche le numro d'erreur du socket, en cas de problme
==============================================================================*/
static void socket_error(char *msg)
{
  char str[255];
  sprintf(str, "Error in function %s, err number: %d\n", msg, WSAGetLastError());
  MessageBox (hwnd,str,"Speech POP3 Error",MB_OK | MB_ICONEXCLAMATION);
  //say(str);
}

/*==============================================================================
  Se connecte au serveur puis envoie des commandes POP3
==============================================================================*/
void mail_check (int x)
{
  SOCKET sk;
  struct sockaddr_in ServAddr;
  struct hostent *he;
  char buf[255]; // paquet envoy au serveur
  int i=-1;      // valeurs de retour
  
  //printf("gethostbyname(%s)\n", b[x].serv);
  if ((he = gethostbyname(b[x].serv)) == NULL)
  {
    socket_error("Gethostbyname()"); return;
  }

  //printf("Socket\n");
  if ((sk = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET)
  {
    socket_error("socket()\n"); return;
  }

  //printf("fill address\n");
  ServAddr.sin_family = AF_INET;
  ServAddr.sin_port   = htons(b[x].port);
  ServAddr.sin_addr   = *((struct in_addr *)he->h_addr);

  //printf("connect()\n");
  if (connect(sk, (struct sockaddr *)&ServAddr, sizeof(ServAddr))==-1)
  {
    socket_error("connect()");
    closesocket(sk);
    return;
  }

  // Envoi des commandes POP3
  i = sprintf(buf, "USER %s\r\n", b[x].n); mail_discuss(sk,buf,i,0,x);
  i = sprintf(buf, "PASS %s\r\n", b[x].p); mail_discuss(sk,buf,i,1,x);
  i = sprintf(buf, "STAT\r\n");            mail_discuss(sk,buf,i,2,x);
  i = sprintf(buf, "QUIT\r\n");            mail_discuss(sk,buf,i,3,x);

  closesocket(sk);
}

/*==============================================================================
  Recoit une rponse du serveur puis envoie une nouvelle commande.
  Paramtres:
   - sk est le descripteur du socket actuellement connect au serveur
   - msg est la commande  envoyer: "USER n", "PASS n", "STAT", ou "QUIT"
   - len est la longueur de la commande  envoyer, utile pour send().
   - Le 'stade' dtermine la commande fatidique qui indique le paquet comportant
     les infos qui nous intressent, par exemple "+OK 25 12544" qui signifie
     "vous avez 25 messages qui occupent 12544 octets"
   - x est l'index de la boite traite
==============================================================================*/
static void mail_discuss (SOCKET sk, char *msg, int len, char stade, int x)
{
  char s[1500]; // les serveurs envoient rarement plus de 1500 octets/paquet
  int i = recv (sk, s, sizeof(s), 0);

    //s[i]=0;
    //printf(s);

  if (i && stade==3)
  {
    s[i]=0;
    // Dcoupe "+OK 25 12544" en 3, rapidement sans strtok()
    //int nbmsg=0;
    //double nboctets=0;
    //sscanf (s,"%*s %d %lf\n", &nbmsg, &nboctets);

    char d[3][255]; int n, cpt=0, a=0;
    for (n=0; n<i-1; n++)
    {
      if (s[n]==' ' || n==i-2) {d[cpt][a]=0; a=0; cpt++;}
      else {d[cpt][a++]=s[n];}
    }
    n = atoi(d[1]);

    // Si le nombre de messages est diffrent depuis la dernire connection
    // pour cette boite, met  jour le tableau et l' affichage 
    if (n != c[x].nbmessages)
    {
      // Transforme "12544" en "12.25Ko"
      double nboctets = atof(d[2]);
      if (nboctets)
      {
          char octets[100];
          if (nboctets < 1024)
                 sprintf(c[x].taille_msg, " (%s octets)", d[1]);
          else if (nboctets < 1048576)
                 sprintf(c[x].taille_msg, " (%.1lf Ko)", nboctets/1024);
          else   sprintf(c[x].taille_msg, " (%.1lf Mo)", nboctets/1024/1024);
      }

      sprintf(s,"%s: %s email%s%s\n",
                            b[x].nom,
                           (n<1)?"Pas d'":d[1], 
                           (n>1)?"s":"",
                           (n>0)?c[x].taille_msg:".");
      SetDlgItemText(hwnd, 404, s);
      c[x].nbmessages = n;

      // DIS-LE
      sprintf(msg, "Mailbox, %s... you have %s email%s",
                           b[x].nom, (n<1)?"no":d[1], (n>1)?"s":"");
      dire(msg);
    }
  }

  // Envoie au serveur la commande spcifie en argument
  i = send(sk, msg, len, 0);
  if (i != len) socket_error("send()");
  
  // Et attend le temps que le serveur la traite. Ce sleep garantit que les
  // paquets reus seront dans le bon ordre, avec 0% CPU.
  sleep(100);
}





     
