/* Speech API et serveur de courrier POP3 - Katsankat */

#include "mail.h"
#include "systray.h"

HINSTANCE hinst;
HANDLE hwnd;
BOOL CALLBACK DlgConfig(HWND,UINT,WPARAM,LPARAM);

/* =============================================================================
   POINT D'ENTREE
==============================================================================*/
int WINAPI WinMain(HINSTANCE inst, HINSTANCE prev, PSTR CmdLine, int iCmdShow)
{
   hinst = inst;
   hwnd = CreateDialog(inst, MAKEINTRESOURCE(100), NULL, DlgConfig);

   HICON hIcon1,hIcon2;
   hIcon1 = LoadIcon(inst,MAKEINTRESOURCE(2));
   hIcon2 = LoadIcon(inst,MAKEINTRESOURCE(2));
   SendMessage(hwnd,WM_SETICON,(WPARAM)ICON_SMALL,(LPARAM)hIcon1);
   SendMessage(hwnd,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)hIcon2);

   ShowWindow (hwnd, iCmdShow);
   UpdateWindow(hwnd);

   MSG msg;
   while (GetMessage(&msg, NULL, 0, 0))
   {
     TranslateMessage (&msg);
     DispatchMessage  (&msg);
   }
   return msg.wParam;
}

/* =============================================================================
   Dis un message.
   Change l'icone du systray et invoque la fonction say de la dll
==============================================================================*/
void dire(char *msg)
{
  systray_ChangeIcon(hinst, 1,hwnd, MAKEINTRESOURCE(3), "Speech POP3");
  say(msg);
  systray_ChangeIcon(hinst, 1,hwnd, MAKEINTRESOURCE(2), "Speech POP3");
}

/* =============================================================================
   VIDE TOUTES LES ZONES DE SAISIE
==============================================================================*/
static void Vider_Entry()
{
  SetDlgItemText(hwnd, 201, "");
  SetDlgItemText(hwnd, 203, "");
  SetDlgItemText(hwnd, 205, "");
  SetDlgItemText(hwnd, 207, "");
  SetDlgItemText(hwnd, 209, "");
  SetDlgItemText(hwnd, 207, "");
  SetDlgItemText(hwnd, 212, "");
}

/* =============================================================================
   CLIC BOUTON "AJOUTER BOITE"
==============================================================================*/
static void Ajouter_Boite()
{
  CHAR str[255];
  char flag=0;
  boite tmp;
  HWND hList = GetDlgItem(hwnd,101);

  // obtient texte serv , le passe dans la boite tmp
     GetDlgItemText(hwnd, 201, str, 255);
     if (!str[0]) flag=1;
     else sprintf(tmp.serv, "%s", str); str[0]=0;

  // obtient texte port , le passe dans la boite tmp
     GetDlgItemText(hwnd, 203, str, 4);
     if (!str[0]) flag=1;
     else tmp.port = atoi(str); str[0]=0;

  // obtient texte email, le passe dans la boite tmp
     GetDlgItemText(hwnd, 205, str, 255);
     if (!str[0]) flag=1;
     else sprintf(tmp.n, "%s", str); str[0]=0;

  // obtient texte passe, le passe dans la boite tmp
     GetDlgItemText(hwnd, 207, str, 40);
     if (!str[0]) flag=1;
     else sprintf(tmp.p, "%s", str); str[0]=0;

  // obtient intervalle , le passe dans la boite tmp
     GetDlgItemText(hwnd, 212, str, 10);
     if (!str[0]) flag=1;
     else tmp.intervalle = atoi(str); str[1]=0;

  // obtient texte nom  , le passe dans la boite tmp
     GetDlgItemText(hwnd, 209, str, 255);
     if (!str[0]) flag=1;
     else sprintf(tmp.nom, "%s", str);

  // Si tous les champs sont remplis,
     if (!flag)
     {
      // realloc tableau
         b = (boite*) realloc(b, (nbboites+1)* sizeof(boite));
         c = (check*) realloc(c, (nbboites+1)* sizeof(check));
      // copie boite temporaire dans tableau
         sprintf(b[nbboites].serv, "%s", tmp.serv);
         sprintf(b[nbboites].n   , "%s", tmp.n   );
         sprintf(b[nbboites].p   , "%s", tmp.p   );
         sprintf(b[nbboites].nom , "%s", tmp.nom );
         // spcifie autres infos dans le tableau
                 b[nbboites].port       = tmp.port;
                 b[nbboites].intervalle = tmp.intervalle;

                 c[nbboites].next_check = 2;
                 c[nbboites].nbmessages = -1;
          strcpy(c[nbboites].taille_msg,"(0 Ko)");
                   nbboites++;
      // Ajoute item  la liste
         SendMessage(hList,LB_ADDSTRING,0,(LONG)str);
      // Dslectionne tout item de la liste
         SendDlgItemMessage(hwnd, 101, LB_SETCURSEL, -1, 0);
      // Vide les zones de saisie et crit le fichier
         Vider_Entry();
         junk_Ecrire_Fichier();
    }
    else dire("Sorry, but to add a new mailbox, you have to fill all the fields.");
}

/* =============================================================================
   CLIC BOUTON "SUPPRIMER BOITE"
==============================================================================*/
static void Supprimer_Boite()
{
  // Retire de la liste celui qui est slectionn
     UINT id = SendDlgItemMessage(hwnd, 101, LB_GETCURSEL, 0, 0);
     if (id==-1)
     {
       dire("Sorry but you have to select a mailbox in the list on the left, then delete it.");
       return;
     }
     SendDlgItemMessage(hwnd, 101, LB_DELETESTRING, id, 0);

  // Dans le tableau, dcale de -1  partir de l'index  supprimer
     register int n;
     for (n=id; n<nbboites; n++)
     {
       sprintf(b[n].serv, "%s", b[n+1].serv);
       sprintf(b[n].n   , "%s", b[n+1].n);
       sprintf(b[n].p   , "%s", b[n+1].p);
       sprintf(b[n].nom , "%s", b[n+1].nom);
               b[n].port       = b[n+1].port;
               b[n].intervalle = b[n+1].intervalle;

               c[n].nbmessages = c[n+1].nbmessages;
               c[n].next_check = c[n+1].next_check;
       sprintf(c[n].taille_msg,"%s",c[n+1].taille_msg);
     }

  // Ralloue tableau
     nbboites--;
     b = (boite*) realloc(b, nbboites* sizeof(boite));
     c = (check*) realloc(c, nbboites* sizeof(check));
  
  // Vide les zones de saisie et crit le fichier
     Vider_Entry();
     junk_Ecrire_Fichier();
}

/* =============================================================================
   CLIC SUR UN ITEM DE LISTE
==============================================================================*/
static void Voir_Enregistrement()
{
   // obtient l'index de l'item slectionn dans la liste
   UINT id = SendDlgItemMessage(hwnd, 101, LB_GETCURSEL, 0, 0);
   if (id != -1) 
   {
     char str[200];
     // remplit contrles d'aprs donnes du tableau de structures
     SetDlgItemText(hwnd, 201, b[id].serv);
     sprintf(str, "%d",     b[id].port);
     SetDlgItemText(hwnd, 203, str       );
     SetDlgItemText(hwnd, 205, b[id].n   );
     SetDlgItemText(hwnd, 207, b[id].p   );
     SetDlgItemText(hwnd, 209, b[id].nom );
     sprintf(str, "%d",     b[id].intervalle);
     SetDlgItemText(hwnd, 212, str       );

     if (c[id].nbmessages < 1)
        sprintf(str, "Pas d' email.");
     else
        sprintf(str,"%d email%s%s\n",
                            c[id].nbmessages, 
                           (c[id].nbmessages>1)?"s":"",
                           (c[id].nbmessages>0)?c[id].taille_msg:"");
     SetDlgItemText(hwnd, 404, str);
   }
}

/* =============================================================================
   CLIC SUR BOUTON "SAY MY NAME"
==============================================================================*/
static void say_name()
{
   char str[255];
   GetDlgItemText(hwnd, 209, str, 255);
   dire(str); 
}

/* =============================================================================
   Initialisation application
==============================================================================*/
static void init_Application(HANDLE h)
{
   // Retire app du taskbar
      ShowWindow(hwnd, 0);

   // Charge le tableau de structures
      junk_Lire_Infos_Stockees();
   // puis le listbox
      HWND hList = GetDlgItem(h,101);
      register int n;
      for (n=0; n<nbboites; n++)
         SendMessage(hList,LB_ADDSTRING,0,(LONG)b[n].nom);

   // Lance le thread de connection priodique
      mail_Check_Periodique();
}

/* =============================================================================
   VERIFIER MAINTENANT LA BOITE DE MESSAGERIE SELECTIONNEE DANS LA LISTE
==============================================================================*/
static void check_now_particular_mailbox()
{
   UINT id = SendDlgItemMessage(hwnd, 101, LB_GETCURSEL, 0, 0);
   if  (id != -1)
   {
     mail_check(id);
     c[id].next_check = b[id].intervalle;
   }
}

/* =============================================================================
   CALLBACK FENETRE
==============================================================================*/
BOOL CALLBACK DlgConfig(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch (uMsg)
  {
    case WM_INITDIALOG:
              init_Application(hWnd);
              break;

    case WM_SYSCOMMAND: // passe en systray ds que minimis
	     if (LOWORD(wParam)== SC_MINIMIZE)
         {
           ShowWindow(hwnd, SW_HIDE);
           systray_AddIcon(hinst, 1, hwnd, MAKEINTRESOURCE(2),"Speech POP3");
           return TRUE;
         }
         break;

    case WM_COMMAND:
       switch(LOWORD(wParam))
       {
         case 101: // Clic sur liste
                      Voir_Enregistrement();
                      break;

         case 151: // Ajouter boite
                      Ajouter_Boite();
                      break;

         case 152: // Supprimer boite
                      Supprimer_Boite();
                      break;

         case 210: // Say my name
                      say_name();
                      break;


         case 153: // Vrifier maintenant la boite slectionne
                      check_now_particular_mailbox();
                      break;

         default: break;
       }
       break;

    case WM_TRAY_ICONE: // CLIC SYSTRAY
       if(lParam == WM_RBUTTONUP || lParam == WM_LBUTTONUP)
       {
         ShowWindow(hwnd, SW_SHOW);
         systray_DelIcon(hwnd,1);
         return TRUE;
       }
       break;
		  
    case WM_CLOSE:
           WSACleanup();
           PostQuitMessage(0);
           break;

    default: return FALSE;
  }
  return 0;
}
