#include "systray.h"

/*==============================================================================
 Ajouter l'icone au systray
==============================================================================*/
BOOL systray_AddIcon(HINSTANCE hInst, UINT id, HWND hWnd, LPTSTR IconName, char *tooltip)
{
	BOOL res;
	NOTIFYICONDATA trid;
	               trid.cbSize = sizeof(NOTIFYICONDATA);
                   trid.hWnd   = hWnd;
	               trid.uID    = id;
	               trid.uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP;
	               trid.uCallbackMessage = WM_TRAY_ICONE;
                   trid.hIcon  = LoadIcon(hInst, IconName);
 
	if (tooltip)
		lstrcpyn(trid.szTip, tooltip, sizeof(trid.szTip));
	else
		trid.szTip[0] = 0;

	res = Shell_NotifyIcon(NIM_ADD, &trid);
    ShowWindow(hWnd, SW_HIDE);

	return res;
}

/*==============================================================================
 Changer l'icone du systray
==============================================================================*/
BOOL systray_ChangeIcon(HINSTANCE hInst, UINT id, HWND hWnd, LPTSTR IconName, char *tooltip)
{
	NOTIFYICONDATA trid;
	               trid.cbSize = sizeof(NOTIFYICONDATA);
	               trid.hWnd   = hWnd;
	               trid.uID    = id;
                   trid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	               trid.uCallbackMessage = WM_TRAY_ICONE;
	               trid.hIcon  = LoadIcon(hInst, IconName);

	if (tooltip)
		lstrcpyn(trid.szTip, tooltip, sizeof(trid.szTip));
	else
		trid.szTip[0] = 0;

	return Shell_NotifyIcon(NIM_MODIFY, &trid);
}

/*==============================================================================
 Retire l'icone du systray
==============================================================================*/
BOOL systray_DelIcon(HWND hWnd, UINT id)
{
	NOTIFYICONDATA trid;
	               trid.cbSize = sizeof(NOTIFYICONDATA);
	               trid.hWnd   = hWnd;
	               trid.uID    = id;
    ShowWindow(hWnd, SW_SHOW);
	return Shell_NotifyIcon(NIM_DELETE, &trid);
}
